----------------------------------------------------------------------------------------------------
--Author: Falkkor-----------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
--"Imitation is the sincerest form of flattery that mediocrity can pay to greatness."---------------
----------------------------------------------------------------------------------------------------

source(Utils.getFilename("xtremeSpeedUnlocker.lua", g_currentModDirectory));

function installSpec()
	if g_specializationManager:getSpecializationByName("xtremeSpeedUnlocker") == nil then
		if xtremeSpeedUnlocker == nil then 
			print("ERROR: unable to find source file 'xtremeSpeedUnlocker.lua'");
		else 
			for typeName, typeDef in pairs(g_vehicleTypeManager.types) do
				if typeDef ~= nil and (typeName ~= "locomotive") then 
					local isWashable = false;
					local hasEngine = false;
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "washable" then 
							isWashable = true;
						elseif name == "motorized" then 
							hasEngine = true;
						end;
					end;
					if isWashable and hasEngine then
						 if typeDef.specializationsByName["xtremeSpeedUnlocker"] == nil then
							table.insert(typeDef.specializations, xtremeSpeedUnlocker);
							table.insert(typeDef.specializationNames, "xtremeSpeedUnlocker");
							typeDef.specializationsByName["xtremeSpeedUnlocker"] = xtremeSpeedUnlocker;
						end;
					end;
				end;
			end;
		end;	
	end;
end;

TypeManager.validateTypes = Utils.appendedFunction(TypeManager.validateTypes, installSpec);